﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

using System.Configuration;
   // Accessing Connectiong String from web.config (Optional)
using System.Data;
   // Required to Create Dataset. 
using System.Data.SqlClient;
   // Required to Create SQLConnection etc.
using System.Data.OleDb;
   // Required to create OleDb connection and reader.
using System.IO;
   // Uploading File in system. Path is class of this namespace.

public partial class _Default : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {

    }
    protected void Button1_Click(object sender, EventArgs e)
    {
        if (fileUpload1.HasFile)
        {
            string fileName = Path.GetFileName(fileUpload1.PostedFile.FileName);
            string fileExt = Path.GetExtension(fileUpload1.PostedFile.FileName);
            string uploadPath = "~/Uploads/";
            string filePath = Server.MapPath(uploadPath + fileName);
            fileUpload1.SaveAs(filePath);
            string conStr = "";
            if (fileExt == ".xls" || fileExt == "XLS")
            {
                conStr = "Provider=Microsoft.Jet.OLEDB.4.0; Data Source='" + filePath + "'" + "; Extended Properties ='Excel 8.0;HDR=Yes'";
            }
            else if (fileExt == ".xlsx" || fileExt == "XLSX")
            {
                conStr = "Provider=Microsoft.ACE.OLEDB.12.0; Data Source=" + filePath + "; Extended Properties ='Excel 8.0;HDR=Yes'";
            }
            conStr = string.Format(conStr, filePath);
            OleDbConnection con = new OleDbConnection(conStr);
            try
            {
                con.Open();
                OleDbDataAdapter adp = new OleDbDataAdapter("Select * from [Sheet1$]", con);
                DataSet ds = new DataSet();
                adp.Fill(ds);
                gridView1.DataSource = ds.Tables[0].DefaultView;
                gridView1.DataBind();
            }
            catch (Exception ex)
            {

                throw ex;
            }
            finally
            {
                con.Dispose();
            }
        }
    }
    protected void Button2_Click(object sender, EventArgs e)
    {
        string excelConnectionString = string.Empty;
        string uploadPath = "~/Uploads/";
        string filePath = Server.MapPath(uploadPath + fileUpload1.PostedFile.FileName);
        string fileExt = Path.GetExtension(fileUpload1.PostedFile.FileName);
        String strConnection = ConfigurationManager.ConnectionStrings["conn"].ConnectionString;
        if (fileExt == ".xls" || fileExt == "XLS")
        {
            excelConnectionString = "Provider=Microsoft.Jet.OLEDB.4.0; Data Source='" + filePath + "'" + "; Extended Properties ='Excel 8.0;HDR=Yes'";
        }
        else if (fileExt == ".xlsx" || fileExt == "XLSX")
        {
            excelConnectionString = @"Provider=Microsoft.ACE.OLEDB.12.0;Data Source=" + filePath + ";Extended Properties=Excel 12.0;Persist Security Info=False";
        }
        OleDbConnection excelConnection = new OleDbConnection(excelConnectionString);
        OleDbCommand cmd = new OleDbCommand("Select * from [Sheet1$]", excelConnection);
        excelConnection.Open();
        OleDbDataReader dReader;
        dReader = cmd.ExecuteReader();
        SqlBulkCopy sqlBulk = new SqlBulkCopy(strConnection);
        sqlBulk.DestinationTableName = "Result";
        sqlBulk.WriteToServer(dReader);
        lblStatus.Text = "Congratulations! Successfully Imported.";
        excelConnection.Close();
    }
}